using System;
using System.Drawing;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Globalization;

namespace CustomControlFreak
{
    public enum eTimeMode { Hours24, Hours12 };

    [ToolboxData("<{0}:TimeMachine runat=server></{0}:TimeMachine>")]
    [ToolboxBitmapAttribute(typeof(TimeMachine), "CustomControlFreak.calendar.bmp")]
    public class TimeMachine : WebControl, IPostBackDataHandler
    {
        #region properties

        private bool validDateSelected = false;
        private TimeSpan time = new TimeSpan();
        private bool showMinutes = true;
        private bool showSeconds = false;
        private bool showMiliseconds = false;
        private eTimeMode timeMode = eTimeMode.Hours24;
        private DateTime selectedTime = DateTime.Now;               // default selected time
        private DateTime defaultDisplayTime = DateTime.Now;         // default display time
        private string cultureName = CultureInfo.CurrentCulture.Name;   // default culture
        private CultureInfo culture;

        //[Bindable(true), Category("Behavior"), DefaultValue(""), Description("The default selected date")]
        //public DateTime SelectedDate
        //{
        //    get
        //    {
        //        try
        //        {
        //            return (DateTime)ViewState["SelectedDate"];
        //        }
        //        catch { return new DateTime(); }

        //    }
        //    set
        //    {
        //        validDateSelected = true;
        //        ViewState["SelectedDate"] = defaultDisplayDate = value;
        //    }
        //}

        [Bindable(true), Category("Behavior"), DefaultValue(""), Description("The text in the textbox")]
        public String Text
        {
            get { return (ViewState["txtValue"] != null) ? (string)ViewState["txtValue"] : null; }
            internal set
            {
                try
                {
                    string[] arr = value.Split(new char[] { '/' });

                    //lidDateSelected = true;
                }
                catch
                {
                    //if (ViewState["txtValue"].ToString() == "")
                    //{
                    //    ViewState["SelectedDate"] = new DateTime();
                    //    showDefaultDate = false;
                    //}
                    //else
                    //{
                    //    ViewState["txtValue"] = "";
                    //    showDefaultDate = true;
                    //}

                    
                    validDateSelected = false;
                }
            }
        }

        [Bindable(false), Category("Behavior"), DefaultValue("The selected Time")]
        public TimeSpan Time
        {
            get { return time; }
            set { time = value; }
        }

                [Bindable(false), Category("Behavior"), DefaultValue("")]
        public bool ValidDateSelected
        {
            get { return validDateSelected; }
        }

        [Bindable(false), Category("Behavior"), DefaultValue("")]
        public bool ShowMinutes
        {
            get { return showMinutes; }
            set { showMinutes = value; }
        }

        [Bindable(false), Category("Behavior"), DefaultValue("")]
        public bool ShowSeconds
        {
            get { return showSeconds; }
            set { showSeconds = value; }
        }

        [Bindable(false), Category("Behavior"), DefaultValue("")]
        public bool ShowMiliseconds
        {
            get { return showMiliseconds; }
            set { showMiliseconds = value; }
        }

        [Bindable(true), Category("Behavior"), DefaultValue(false), Description("The calendar type to display")]
        public eTimeMode TimeMode
        {
            get { return timeMode; }
            set { timeMode = value; }
        }

        #endregion

        public TimeMachine()
        {
            this.culture = System.Globalization.CultureInfo.GetCultureInfo(cultureName);
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            string PageContent = "<div>";
            int From = (TimeMode == eTimeMode.Hours24) ? 0 : 1;
            int To = (TimeMode == eTimeMode.Hours24) ? 25 : 13;


            // render the hours
            writer.AddAttribute(HtmlTextWriterAttribute.Name, GetInstanceID()+"Hours");
            writer.RenderBeginTag(HtmlTextWriterTag.Select);

            writer.AddAttribute(HtmlTextWriterAttribute.Value, "");
            writer.RenderBeginTag(HtmlTextWriterTag.Option);
            writer.Write(HttpUtility.HtmlEncode("H"));
            writer.RenderEndTag();

            for (int i = From; i < To; i++)
            {
                writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
                writer.RenderBeginTag(HtmlTextWriterTag.Option);
                writer.Write(HttpUtility.HtmlEncode(i.ToString()));
                writer.RenderEndTag();
            }

            writer.RenderEndTag();

            // render the Minutes
            if (showMinutes)
            {

                writer.AddAttribute(HtmlTextWriterAttribute.Name, GetInstanceID() + "Minutes");
                writer.RenderBeginTag(HtmlTextWriterTag.Select);

                writer.AddAttribute(HtmlTextWriterAttribute.Value, "");
                writer.RenderBeginTag(HtmlTextWriterTag.Option);
                writer.Write(HttpUtility.HtmlEncode("M"));
                writer.RenderEndTag();

                for (int i = 0; i < 60; i++)
                {
                    writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
                    writer.RenderBeginTag(HtmlTextWriterTag.Option);
                    writer.Write(HttpUtility.HtmlEncode(i.ToString()));
                    writer.RenderEndTag();
                }

                writer.RenderEndTag();
            }

            // render the Seconds
            if (showSeconds)
            {

                writer.AddAttribute(HtmlTextWriterAttribute.Name, GetInstanceID() + "Seconds");
                writer.RenderBeginTag(HtmlTextWriterTag.Select);

                writer.AddAttribute(HtmlTextWriterAttribute.Value, "");
                writer.RenderBeginTag(HtmlTextWriterTag.Option);
                writer.Write(HttpUtility.HtmlEncode("S"));
                writer.RenderEndTag();

                for (int i = 0; i < 60; i++)
                {
                    writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
                    writer.RenderBeginTag(HtmlTextWriterTag.Option);
                    writer.Write(HttpUtility.HtmlEncode(i.ToString()));
                    writer.RenderEndTag();
                }

                writer.RenderEndTag();
            }

            // render the Miliseconds
            if (showSeconds)
            {

                writer.AddAttribute(HtmlTextWriterAttribute.Name, GetInstanceID() + "Miliseconds");
                writer.RenderBeginTag(HtmlTextWriterTag.Select);

                writer.AddAttribute(HtmlTextWriterAttribute.Value, "");
                writer.RenderBeginTag(HtmlTextWriterTag.Option);
                writer.Write(HttpUtility.HtmlEncode("MS"));
                writer.RenderEndTag();

                for (int i = 0; i < 1000; i++)
                {
                    string show = i.ToString();

                    if (i < 10)
                        show += "000";
                    else if (i > 9 && i < 100)
                        show += "00";

                    writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
                    writer.RenderBeginTag(HtmlTextWriterTag.Option);
                    writer.Write(HttpUtility.HtmlEncode(i.ToString()));
                    writer.RenderEndTag();
                }

                writer.RenderEndTag();
            }

            if (TimeMode == eTimeMode.Hours12)
            {
                writer.AddAttribute(HtmlTextWriterAttribute.Name, GetInstanceID() + "Miliseconds");
                writer.RenderBeginTag(HtmlTextWriterTag.Select);

                writer.AddAttribute(HtmlTextWriterAttribute.Value, "AM");
                writer.RenderBeginTag(HtmlTextWriterTag.Option);
                writer.Write(HttpUtility.HtmlEncode("AM"));
                writer.RenderEndTag();

                writer.AddAttribute(HtmlTextWriterAttribute.Value, "PM");
                writer.RenderBeginTag(HtmlTextWriterTag.Option);
                writer.Write(HttpUtility.HtmlEncode("PM"));
                writer.RenderEndTag();

                writer.RenderEndTag();
            }

            PageContent += "</div>";

            writer.Write(PageContent);
        }


        #region Postback handling

        public virtual bool LoadPostData(string PostDataKey, NameValueCollection postCollection)
        {
            string x = postCollection[PostDataKey];

            return false;
        }

        public virtual void RaisePostDataChangedEvent()
        {
            //empty
        }

        #endregion

        private string GetInstanceID()
        {
            return this.UniqueID.Replace("$", "a");
        }
    }
}